#include <string.h>
#include <unistd.h>
#include "common.h"

void	processConfig();

char	phNoAreaFormat[16];
char	phNoLocalFormat[16];

void main() {
  char str[256];
  UserRec ur;
  processConfig();
  userFileOpen();
  while (!userFileRead(&ur)) {
    if (!loginFromUID(str, ur.uid)) continue;
    printf("%s ", str);
    if (ur.phNoLocal)
      printf("%s ", wordsToPhNo(str, ur.phNoArea, ur.phNoLocal, phNoAreaFormat, phNoLocalFormat));
    else
      printf("N/A ");
    printf("%d ", (int)PRIORITY(ur.flags));
    printf("%d ", ur.tLeft);
    bytes2ASCII(str, ur.PPPtBytes);
    printf("%s ", str);
    if (ur.expire) {
      if (EXPIRE(ur.flags) == EXPIRE_DELETE) printf("DELETE ");
      else printf("UNSUBSCRIBE ");
    } else printf("N/A ");
    printf("%lu ", ur.expire);
    printf("%lu\n", ur.last);
  }
  userFileClose();
}

void processConfig() {
  int li;
  char line[256], token[256];
  FILE *f;
  if ((f = fopen(configFilePath, "rt")) == NULL)
    errQuit("couldn't open config file");
  while (fgets(line, 256, f) != NULL) {
    li = 0;
    if (getToken(token, line, &li)) continue;
    if (!strcasecmp(token, "PhNoAreaFormat")) {
      if (getToken(token, line, &li)) continue;
      strcpy(phNoAreaFormat, token);
      while (!getToken(token, line, &li)) {
	strcat(phNoAreaFormat, " ");
	strcat(phNoAreaFormat, token);
      }
    } else if (!strcasecmp(token, "PhNoLocalFormat")) {
      if (getToken(token, line, &li)) continue;
      strcpy(phNoLocalFormat, token);
      while (!getToken(token, line, &li)) {
	strcat(phNoLocalFormat, " ");
	strcat(phNoLocalFormat, token);
      }
    }
  }
  fclose(f);
}
