#include <assert.h>
#include <stdlib.h>
#include <unistd.h>
#include "common.h"

void main(int argc, char **argv) {
  uid_t uid;
  UserRec ur;
  int session_limit, priority;
  char tuser[16];
  if (argc < 4)
    errQuit("usage: user_subscribe <login> <expire> <time_limit> [session_limit] [priority]");
  session_limit = argc >= 5 ? atoi(argv[4]) : atoi(argv[3]);
  if (session_limit < 0 || session_limit > atoi(argv[3]))
    errQuit("invalid session_limit: %d", session_limit);
  priority = argc >= 6 ? atoi(argv[5]) : 4;
  if (priority < 0 || priority > 7)
    errQuit("invalid priority: %d", priority);
  uid = uidFromLogin(argv[1]);
  if (uid == (uid_t)-1)
    errQuit("user does not exist: %s", argv[1]);
  strcpy(tuser, "/tmp/XXXXXX"); mktemp(tuser);
  userFileOpen();
  if (userFileSearch(&ur, uid))
    errQuit("user not found: %s", argv[1]);
  if (EXPIRE(ur.flags) == EXPIRE_UNSUBSCRIBE)
    errQuit("user already has a subscription: %s", argv[1]);
  ur.subExpire = ur.expire;
  ur.subFlags = ur.flags;
  ur.subTlimit = ur.tLimit;
  ur.subSlimit = ur.sLimit;
  ur.expire = addTime(argv[2]);
  if (ur.expire <= time(NULL))
    errQuit("illegal expiry date.");
  ur.tLimit = ur.tLeft = atoi(argv[3]);
  ur.sLimit = ur.sLeft = session_limit;
  ur.flags = EXPIRE_UNSUBSCRIBE | (priority << 1);
  userFileEdit(&ur);
  userFileClose();
  printf("user subscribed: %s\n", argv[1]);
}
