#include <assert.h>
#include <stdlib.h>
#include <unistd.h>
#include "common.h"

void main(int argc, char **argv) {
  uid_t uid;
  UserRec ur;
  int session_limit, priority;
  if (argc < 4)
    errQuit("usage: user_time <login> <expire> <time_limit> [session_limit] [priority]");
  session_limit = argc >= 5 ? atoi(argv[4]) : atoi(argv[3]);
  if (session_limit < 0 || session_limit > atoi(argv[3]))
    errQuit("invalid session_limit: %d", session_limit);
  priority = argc >= 6 ? atoi(argv[5]) : 4;
  if (priority < 0 || priority > 7)
    errQuit("invalid priority: %d", priority);
  uid = uidFromLogin(argv[1]);
  if (uid == (uid_t)-1)
    errQuit("user does not exist: %s", argv[1]);
  userFileOpen();
  if (userFileSearch(&ur, uid))
    errQuit("user not found: %s", argv[1]);
  ur.flags = (ur.flags & 0x01) | (priority << 1);
  ur.expire = addTime(argv[2]);
  if (EXPIRE(ur.flags) == EXPIRE_UNSUBSCRIBE && !ur.expire)
    errQuit("<expire> = 0 invalid (user %s has a subscription).", argv[1]);
  ur.tLimit = ur.tLeft = atoi(argv[3]);
  ur.sLimit = ur.sLeft = session_limit;
  userFileEdit(&ur);
  userFileClose();
  printf("user modified: %s\n", argv[1]);
}
