#include <assert.h>
#include <unistd.h>
#include "common.h"

void main(int argc, char **argv) {
  uid_t uid;
  UserRec ur;
  if (argc != 2)
    errQuit("usage: user_unsubscribe <login>");
  uid = uidFromLogin(argv[1]);
  if (uid == (uid_t)-1)
    errQuit("user does not exist: %s", argv[1]);
  userFileOpen();
  if (userFileSearch(&ur, uid))
    errQuit("user not found: %s", argv[1]);
  if (EXPIRE(ur.flags) == EXPIRE_DELETE)
    errQuit("user does not have a subscription: %s", argv[1]);
  ur.flags = ur.subFlags;
  ur.expire = ur.subExpire;
  ur.tLimit = ur.tLeft = ur.subTlimit;
  ur.sLimit = ur.sLeft = ur.subSlimit;
  ur.flags &= ~EXPIRE_UNSUBSCRIBE;
  ur.subExpire = 0;
  ur.subTlimit = 0;
  ur.subSlimit = 0;
  userFileEdit(&ur);
  userFileClose();
  printf("user unsubscribed: %s\n", argv[1]);
}
